﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WpfApp1_workerBinding
{
    public class Worker
    {
        // No CS => VM setter => GUI ==> No INotifyPropertyChanged
        public string WorkerName { get; set; }
        public string Phone { get; set; }
        public bool IsOnVacation { get; set; }
        public bool IsSick { get; set; }

        // 1. Automatic display (no templates)
        // 2. Coded UI tests
        public override string ToString()
        {
            string text = $"{WorkerName} [{Phone}]";
            if (IsSick)
            {
                text += " (is currently sick)";
            }
            if (IsOnVacation)
            {
                text += " (is currently on holiday)";
            }

            return text;
        }

        // For unit tests
        public override bool Equals(object obj)
        {
            if (obj is Worker)
            {
                Worker other = obj as Worker;
                return this.WorkerName == other.WorkerName &&
                    this.Phone == other.Phone &&
                    this.IsSick == other.IsSick &&
                    this.IsOnVacation == other.IsOnVacation;
            }
            else return false;
        }
        public override int GetHashCode()
        {
            //return 0;
            return (WorkerName?.GetHashCode() ?? 0) + (Phone?.GetHashCode() ?? 0);
        }
        public Worker()
        {
            WorkerName = "Unknown Bill"; Phone = "123";
        }
    }

}
